
From: Eric Dumazet <dada1@cosmosbay.com>

Mostobjects returned by __cache_alloc() will be written by the caller,
(but not all callers want to write all the object, but just at the
begining) prefetchw() tells the modern CPU to think about the future
writes, ie start some memory transactions in advance.

Signed-off-by: Eric Dumazet <dada1@cosmosbay.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 mm/slab.c |    4 +++-
 1 files changed, 3 insertions(+), 1 deletion(-)

diff -puN mm/slab.c~mm-slabc-prefetchw-the-start-of-new-allocated-objects mm/slab.c
--- devel/mm/slab.c~mm-slabc-prefetchw-the-start-of-new-allocated-objects	2005-08-30 18:41:22.000000000 -0700
+++ devel-akpm/mm/slab.c	2005-08-30 18:41:22.000000000 -0700
@@ -2166,7 +2166,9 @@ static inline void *__cache_alloc(kmem_c
 		objp = cache_alloc_refill(cachep, flags);
 	}
 	local_irq_restore(save_flags);
-	objp = cache_alloc_debugcheck_after(cachep, flags, objp, __builtin_return_address(0));
+	objp = cache_alloc_debugcheck_after(cachep, flags, objp,
+					__builtin_return_address(0));
+	prefetchw(objp);
 	return objp;
 }
 
_
